/*created 2013 by Volker Mink (aquafish007) <http://www.aquaticsolution.de>*/

//#include <math.h>
#include <LiquidCrystal_I2C.h>
//#include <LiquidCrystal.h>
#include <Wire.h> 
#include <DS1307.h>
#include <EEPROMex.h>
#include <OneWire.h>
#include <DallasTemperature.h>
#include <AFMotor.h>

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ H A R D W A R E +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
//Initialisierung
#define ONE_WIRE_BUS 2       // Data wire is plugged into port 8 on the Arduino
// Setup a oneWire instance to communicate with any OneWire devices (not just Maxim/Dallas temperature ICs) 
OneWire oneWire(ONE_WIRE_BUS); 

// Pass our oneWire reference to Dallas Temperature.  
DallasTemperature sensors(&oneWire); 

// arrays to hold device address
DeviceAddress wasserThermometer, raumThermometer;

//DS1307 rtc(16, 17); //Uno
DS1307 rtc(56, 57);   //Mega
LiquidCrystal_I2C lcd(0x27,16,2);  // set the LCD address to 0x27 for a 20 chars and 4 line display, Backlight PWM PIN 10

//LiquidCrystal lcd(8, 9, 4, 5, 6, 7); 

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ K O N S T A N T E N +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
const int DISPLAY_LETZTE_SEITE = 6;
const int DISPLAY_WARTEZEIT = 4;
const long HOUR = 60 * 60;
const long MINUTE = 60;
const int MAXPWMSTEPS = 4096;

//Hier werden die Tasten des Keyboards festgelegt und müssen je nach Keypad angepasst werden
#define RIGHTKEY 3
#define UPKEY 1
#define DOWNKEY 2
#define LEFTKEY 0
#define SELECTKEY 4

Time rtcClock;
long lTime;
long Sekunde;
long Minute;
long HourTime;

//Variablen Display
int intSekunden;
int intDisplayAktuelleSeite = 0;
int intDisplayLetzteSeite = 0;
int intDisplayWartezeit = 0;

//Menühelper
int SetDisplayHelper = 0;
int SetDisplayHelperDate = 0;

//Menü
int MenuTiefe = 0;
int MenuEbene0 = 0;
int MenuEbene1 = 0;
int MenuEbene2 = 0;
int MenuEbene3 = 0;
boolean FirstSelect = false;

//++++++++++++++++++++++++++++++++++++++++++++++++++++++ H I N T E R G R U N D B E L E U C H T U N G ++++++++++++++++++++++++++++++++++++++++++++++++++
long HintergrundbeleuchtungsAnZeit;
long HintergrundbeleuchtungsAusZeit;
Time HintergrundbeleuchtungAn;
Time HintergrundbeleuchtungAus;
boolean prevBacklightSwitch = 0;
boolean backlightSwitch = 0;

//--------------------------------T E M P E R A T U R - M O D U L E--------------------------------------
double tempWasser = 0;
double tempRaum   = 0;

//-------------------------------- B U Z Z E R / A L A R M P O R T - P O R T  ---------------------------
const int BUZZERPORT = 9;   // Alarm on Digital Pin 1
//-------------------------------------------------------------------------------------------------------
//-------------------------------- L I Q U I D - L E V E L S E N S O R - P O R T  ---------------------------
const int S_Sensor = 24;         // Fill Level Sensors are connected to digital port 24 (Schwimmerschalter 1) Technikbecken Füllstand High
int liquidSensorValue = 0;
//-------------------------------------------------------------------------------------------------------

//HD44780U (LCD-II)Oktal-Codes für Umlaute (-see page 17 on Datasheet for ROM Code: A00-):
//ö =  \357
//ä =  \341
//ü =  \365

//Sonderzeichen:
// ° = \337 oder char(223)

//Hauptmenü; Menüebene0 = 0
char sMenuHaupt[3][17] = {
  "Starten", "Grundeinstellung", "Dosierpumpe" };
const int MENUHAUPT = 2;

//Grundeinstellung-Menü
char sMenuGrundeinstellung[6][17] = {
  "Hauptmen\365", "Datum", "Uhrzeit", "Tag", "LCD An", "LCD Aus"};
const int MENUGRUNDEINSTELLUNG = 5;

//Dosierpumpe-Menü
char sMenuDosierpumpeneinstellung[5][17] = {  
  "Hauptmen\365", "Dosierer 1", "Dosierer 2", "Dosierer 3", "Dosierer 4" }; 
const int MENUDOSIERPUMPENEINSTELLUNG = 4;

//Dosierpumpe-Untermenü
char sMenuDosierpumpeneinstellung2[5][17] = {  
  "Hauptmen\365", "Manuell Betrieb ", "Kalibrieren     ", "Nachf\365llautomat ", "Dosieren        " };
const int MENUDOSIERPUMPENEINSTELLUNG2 = 4;

//--------------------------------D O S I E R P U M P E N - M O D U L E-----------------------------------------------------------------------------
//--------------------------------------------Dosierpumpe 1-----------------------------------------------------------------------------------------
//const int M1_MENUDOSIERPORT_1 = 3;
AF_DCMotor motor1(1);

const int MENUDOSIERER1MANUELL = 1;
char sMenuDosierer1Manuell[MENUDOSIERER1MANUELL + 1][17] = {
  "zur\365ck          ", "Manuell         "  }; //ml in 1 Minute gemessen; wieviel ml soll dosiert werden; wann soll dosiert werden
boolean Dosiermanuell_1;

const int MENUDOSIERER1KALIB = 2;
char sMenuDosierer1Kalib[MENUDOSIERER1KALIB + 1][17] = {
  "zur\365ck          ", "Kalib        ml", "Set Time Loop   " }; //ml in 1 Minute gemessen; wieviel ml soll dosiert werden; wann soll dosiert werden
int Kalibrierung1;
long Endtime1;

const int MENUDOSIERER1NACHFUELL = 1;
char sMenuDosierer1Nachfuell[MENUDOSIERER1NACHFUELL + 1][17] = {
  "zur\365ck          ", "Nachf\365llaut.    "  }; //ml in 1 Minute gemessen; wieviel ml soll dosiert werden; wann soll dosiert werden
boolean Dosiernachfuell_1;

const int MENUDOSIERER1DOSIEREN = 13;
char sMenuDosierer1Dosieren[MENUDOSIERER1DOSIEREN + 1][17] = {
  "zur\365ck          ", "Dosiermenge   ml", "Dos-Zeit1       ", "Dos-Zeit2       ", "Dos-Zeit3       ", "Dos-Zeit4       ", "Dos-Zeit5       ", "Dos-Zeit6       ", "Dos-Zeit7       ", "Dos-Zeit8       ", "Dos-Zeit9       ", "Dos-Zeit10      ", "Dos-Zeit11      ", "Dos-Zeit12      " }; //ml in 1 Minute gemessen; wieviel ml soll dosiert werden; wann soll dosiert werden
int Dosiermenge1;
Time Dosierung1_1;
Time Dosierung1_2;
Time Dosierung1_3;
Time Dosierung1_4;
Time Dosierung1_5;
Time Dosierung1_6;
Time Dosierung1_7;
Time Dosierung1_8;
Time Dosierung1_9;
Time Dosierung1_10;
Time Dosierung1_11;
Time Dosierung1_12;
long Dosierdauer1;
long Dosierautomatzeit1_1;
long Dosierautomatzeit1_2;
long Dosierautomatzeit1_3;
long Dosierautomatzeit1_4;
long Dosierautomatzeit1_5;
long Dosierautomatzeit1_6;
long Dosierautomatzeit1_7;
long Dosierautomatzeit1_8;
long Dosierautomatzeit1_9;
long Dosierautomatzeit1_10;
long Dosierautomatzeit1_11;
long Dosierautomatzeit1_12;
//-----------------------------------------bis hier hin:  Dosierpumpe 1-------------------------------------------------------------------------------

//--------------------------------------------Dosierpumpe 2-----------------------------------------------------------------------------------------
//const int M1_MENUDOSIERPORT_2 = 4;
AF_DCMotor motor2(2);

const int MENUDOSIERER2MANUELL = 1;
char sMenuDosierer2Manuell[MENUDOSIERER2MANUELL + 1][17] = {
  "zur\365ck          ", "Manuell         "  }; //ml in 1 Minute gemessen; wieviel ml soll dosiert werden; wann soll dosiert werden
boolean Dosiermanuell_2;

const int MENUDOSIERER2KALIB = 2;
char sMenuDosierer2Kalib[MENUDOSIERER2KALIB + 1][17] = {
  "zur\365ck          ", "Kalib        ml", "Set Time Loop   " }; //ml in 1 Minute gemessen; wieviel ml soll dosiert werden; wann soll dosiert werden
int Kalibrierung2;
long Endtime2;

const int MENUDOSIERER2NACHFUELL = 1;
char sMenuDosierer2Nachfuell[MENUDOSIERER2NACHFUELL + 1][17] = {
  "zur\365ck          ", "Nachf\365llaut.    "  }; //ml in 1 Minute gemessen; wieviel ml soll dosiert werden; wann soll dosiert werden
boolean Dosiernachfuell_2;

const int MENUDOSIERER2DOSIEREN = 13;
char sMenuDosierer2Dosieren[MENUDOSIERER2DOSIEREN + 1][17] = {
  "zur\365ck          ", "Dosiermenge   ml", "Dos-Zeit1       ", "Dos-Zeit2       ", "Dos-Zeit3       ", "Dos-Zeit4       ", "Dos-Zeit5       ", "Dos-Zeit6       ", "Dos-Zeit7       ", "Dos-Zeit8       ", "Dos-Zeit9       ", "Dos-Zeit10      ", "Dos-Zeit11      ", "Dos-Zeit12      " }; //ml in 1 Minute gemessen; wieviel ml soll dosiert werden; wann soll dosiert werden
int Dosiermenge2;
Time Dosierung2_1;
Time Dosierung2_2;
Time Dosierung2_3;
Time Dosierung2_4;
Time Dosierung2_5;
Time Dosierung2_6;
Time Dosierung2_7;
Time Dosierung2_8;
Time Dosierung2_9;
Time Dosierung2_10;
Time Dosierung2_11;
Time Dosierung2_12;
long Dosierdauer2;
long Dosierautomatzeit2_1;
long Dosierautomatzeit2_2;
long Dosierautomatzeit2_3;
long Dosierautomatzeit2_4;
long Dosierautomatzeit2_5;
long Dosierautomatzeit2_6;
long Dosierautomatzeit2_7;
long Dosierautomatzeit2_8;
long Dosierautomatzeit2_9;
long Dosierautomatzeit2_10;
long Dosierautomatzeit2_11;
long Dosierautomatzeit2_12;
//-----------------------------------------bis hier hin:  Dosierpumpe 2-------------------------------------------------------------------------------

//--------------------------------------------Dosierpumpe 3-----------------------------------------------------------------------------------------
//const int M1_MENUDOSIERPORT_3 = 5;
AF_DCMotor motor3(3);

const int MENUDOSIERER3MANUELL = 1;
char sMenuDosierer3Manuell[MENUDOSIERER3MANUELL + 1][17] = {
  "zur\365ck          ", "Manuell         "  }; //ml in 1 Minute gemessen; wieviel ml soll dosiert werden; wann soll dosiert werden
boolean Dosiermanuell_3;

const int MENUDOSIERER3KALIB = 2;
char sMenuDosierer3Kalib[MENUDOSIERER3KALIB + 1][17] = {
  "zur\365ck          ", "Kalib        ml", "Set Time Loop   " }; //ml in 1 Minute gemessen; wieviel ml soll dosiert werden; wann soll dosiert werden
int Kalibrierung3;
long Endtime3;

const int MENUDOSIERER3NACHFUELL = 1;
char sMenuDosierer3Nachfuell[MENUDOSIERER3NACHFUELL + 1][17] = {
  "zur\365ck          ", "Nachf\365llaut.    "  }; //ml in 1 Minute gemessen; wieviel ml soll dosiert werden; wann soll dosiert werden
boolean Dosiernachfuell_3;

const int MENUDOSIERER3DOSIEREN = 13;
char sMenuDosierer3Dosieren[MENUDOSIERER3DOSIEREN + 1][17] = {
  "zur\365ck          ", "Dosiermenge   ml", "Dos-Zeit1       ", "Dos-Zeit2       ", "Dos-Zeit3       ", "Dos-Zeit4       ", "Dos-Zeit5       ", "Dos-Zeit6       ", "Dos-Zeit7       ", "Dos-Zeit8       ", "Dos-Zeit9       ", "Dos-Zeit10      ", "Dos-Zeit11      ", "Dos-Zeit12      " }; //ml in 1 Minute gemessen; wieviel ml soll dosiert werden; wann soll dosiert werden
int Dosiermenge3;
Time Dosierung3_1;
Time Dosierung3_2;
Time Dosierung3_3;
Time Dosierung3_4;
Time Dosierung3_5;
Time Dosierung3_6;
Time Dosierung3_7;
Time Dosierung3_8;
Time Dosierung3_9;
Time Dosierung3_10;
Time Dosierung3_11;
Time Dosierung3_12;
long Dosierdauer3;
long Dosierautomatzeit3_1;
long Dosierautomatzeit3_2;
long Dosierautomatzeit3_3;
long Dosierautomatzeit3_4;
long Dosierautomatzeit3_5;
long Dosierautomatzeit3_6;
long Dosierautomatzeit3_7;
long Dosierautomatzeit3_8;
long Dosierautomatzeit3_9;
long Dosierautomatzeit3_10;
long Dosierautomatzeit3_11;
long Dosierautomatzeit3_12;
//-----------------------------------------bis hier hin:  Dosierpumpe 3-------------------------------------------------------------------------------

//--------------------------------------------Dosierpumpe 3-----------------------------------------------------------------------------------------
//const int M1_MENUDOSIERPORT_4 = 6;
AF_DCMotor motor4(4);

const int MENUDOSIERER4MANUELL = 1;
char sMenuDosierer4Manuell[MENUDOSIERER4MANUELL + 1][17] = {
  "zur\365ck          ", "Manuell         "  }; //ml in 1 Minute gemessen; wieviel ml soll dosiert werden; wann soll dosiert werden
boolean Dosiermanuell_4;

const int MENUDOSIERER4KALIB = 2;
char sMenuDosierer4Kalib[MENUDOSIERER4KALIB + 1][17] = {
  "zur\365ck          ", "Kalib        ml", "Set Time Loop   " }; //ml in 1 Minute gemessen; wieviel ml soll dosiert werden; wann soll dosiert werden
int Kalibrierung4;
long Endtime4;

const int MENUDOSIERER4NACHFUELL = 1;
char sMenuDosierer4Nachfuell[MENUDOSIERER4NACHFUELL + 1][17] = {
  "zur\365ck          ", "Nachf\365llaut.    "  }; //ml in 1 Minute gemessen; wieviel ml soll dosiert werden; wann soll dosiert werden
boolean Dosiernachfuell_4;

const int MENUDOSIERER4DOSIEREN = 13;
char sMenuDosierer4Dosieren[MENUDOSIERER4DOSIEREN + 1][17] = {
  "zur\365ck          ", "Dosiermenge   ml", "Dos-Zeit1       ", "Dos-Zeit2       ", "Dos-Zeit3       ", "Dos-Zeit4       ", "Dos-Zeit5       ", "Dos-Zeit6       ", "Dos-Zeit7       ", "Dos-Zeit8       ", "Dos-Zeit9       ", "Dos-Zeit10      ", "Dos-Zeit11      ", "Dos-Zeit12      " }; //ml in 1 Minute gemessen; wieviel ml soll dosiert werden; wann soll dosiert werden
int Dosiermenge4;
Time Dosierung4_1;
Time Dosierung4_2;
Time Dosierung4_3;
Time Dosierung4_4;
Time Dosierung4_5;
Time Dosierung4_6;
Time Dosierung4_7;
Time Dosierung4_8;
Time Dosierung4_9;
Time Dosierung4_10;
Time Dosierung4_11;
Time Dosierung4_12;
long Dosierdauer4;
long Dosierautomatzeit4_1;
long Dosierautomatzeit4_2;
long Dosierautomatzeit4_3;
long Dosierautomatzeit4_4;
long Dosierautomatzeit4_5;
long Dosierautomatzeit4_6;
long Dosierautomatzeit4_7;
long Dosierautomatzeit4_8;
long Dosierautomatzeit4_9;
long Dosierautomatzeit4_10;
long Dosierautomatzeit4_11;
long Dosierautomatzeit4_12;
//-----------------------------------------bis hier hin:  Dosierpumpe 3-------------------------------------------------------------------------------


//-------------------------------------------------------------------------------------------------------

// Tasten
//int adc_key_val[5] ={50, 220, 430, 630, 990 };
int adc_key_val[5] ={ 
  50, 200, 400, 600, 800 };
int NUM_KEYS = 5;
int adc_key_in;
int key=-1;
int oldkey=-1;



void setup() 
{
  Serial.begin(9600);
  //lcd.begin(16, 2);
  
  lcd.init();
  lcd.backlight();

  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("Init...");


  //Unsere Uhr
  rtc.halt(false);
  
  //Thermometer
  sensors.begin();             // Start up the DS18B20 Temp library
  if (!sensors.getAddress(wasserThermometer, 0)) Serial.println("Unable to find address for Device 0"); 
  if (!sensors.getAddress(raumThermometer, 1)) Serial.println("Unable to find address for Device 1");
  
  // set the resolution to 9 bit (Each Dallas/Maxim device is capable of several different resolutions)
  //sensors.setResolution(wasserThermometer, 9);
  //sensors.setResolution(raumThermometer, 9);

  //Dosierautomat
  //Wenn im EEPROM noch nichts drinnen steht und damit keine komischen Zahlen beim Auslesen des EEPROMS kommen, kann man Default-Werte setzen, die beim allerersten Start gesetzt werden
  // Ein Beschreibungszyklus dauert 3.3 ms, ich gebe Ihm mal 5 ms.
  // Zur Information: Das Beschreiben des EEPROMS ist "nur" 100.000 mal möglich, danach ist es kaputt!
  Serial.print("EEPROM Wert:   ");
  Serial.println(EEPROM.readInt(0));
  requestEEPROM();
 
  
  //Alle PinModes
  //pinMode(M1_MENUDOSIERPORT_1, OUTPUT);
  //pinMode(M1_MENUDOSIERPORT_2, OUTPUT);
  //pinMode(M1_MENUDOSIERPORT_3, OUTPUT);
  //pinMode(M1_MENUDOSIERPORT_4, OUTPUT);
  pinMode(BUZZERPORT, OUTPUT); // set a pin for buzzer output
  pinMode(S_Sensor, INPUT); // set a pin for liquidsensor output
  
  //Initial Buzzing 
  //Untere 2 Zeilen Auskommentieren, wenn man beim Einschalten des Gerätes einen Ton hören möchte
  buzz(BUZZERPORT, 2500, 200); // buzz the buzzer on pin 48 at 2500Hz for 200 milliseconds
  buzz(BUZZERPORT, 3500, 200); // buzz the buzzer on pin 48 at 3500Hz for 200 milliseconds

}

void loop() 
{
  Time time = rtc.getTime();

  //Display
  if (intSekunden != time.sec && MenuTiefe == 0)
  {
    if (intDisplayWartezeit == DISPLAY_WARTEZEIT)
    {
      Display(intDisplayAktuelleSeite);
      intDisplayAktuelleSeite++;

      if (intDisplayAktuelleSeite == DISPLAY_LETZTE_SEITE)
        intDisplayAktuelleSeite = 0;

      intDisplayWartezeit = 0;  
    }
    intSekunden = time.sec ;
    intDisplayWartezeit++;
    
    // DS18B20 display
    requestTemperature(raumThermometer);
    requestTemperature(wasserThermometer);
    
  }  


  key = 0;
  adc_key_in = analogRead(0);
  key = get_key(adc_key_in);
  if (key != oldkey)
  {
    delay(50);
    adc_key_in = analogRead(0);
    key = get_key(adc_key_in);
    if (key != oldkey)
    {
      oldkey = key;

      if (key >=0)
      {
        MenuWerteAuswahl();
        MenuWerteSetzen();       
      }
    }
  }  

  //Jetz geht's los
  //++++++++++++++++++++++++++++++++++++++++++++++++++++++ A K T U E L L E  Z E I T ++++++++++++++++++++++++++++++++++++++++++++++++++
  lTime = (time.hour * HOUR) + (time.min * MINUTE) + time.sec;
  Sekunde = time.sec;
  Minute = (time.min * MINUTE);
  HourTime = Sekunde + Minute;
  
  //++++++++++++++++++++++++++++++++++++++++++++++++++++++ H I N T E R G R U N D B E L E U C H T U N G ++++++++++++++++++++++++++++++++++++++++++++++++++
  // Hier wird eingestellt wann sich die Hintergrundbeleuchtung für das Display ausschalten soll
  HintergrundbeleuchtungsAnZeit = (HintergrundbeleuchtungAn.hour * HOUR);
  HintergrundbeleuchtungsAusZeit = (HintergrundbeleuchtungAus.hour * HOUR);
  
  if (MenuTiefe > 0)
      {
        lcd.backlight();
        backlightSwitch = 1;
      }
            
  else if (((lTime >= HintergrundbeleuchtungsAusZeit) || (lTime <= HintergrundbeleuchtungsAnZeit) ) && (MenuTiefe == 0) )
     { 
       lcd.noBacklight(); 
     }
  else
     { 
       lcd.backlight();
     }
    
    if (backlightSwitch != prevBacklightSwitch)
    {
        if (backlightSwitch == 1)
          {
              lcd.backlight();
          }
          
     prevBacklightSwitch = backlightSwitch;
    }
  
  //++++++++++++++++++++++++++++++++++++++++++++++++++++++ S C H W I M M E R S E N S O R    A U S L E S E N / S T A T U S A B F R A G E ++++++++++++++++++++++++++++++++++++++++++++++++++
  liquidSensorValue = digitalRead(S_Sensor);
//  Serial.print("Sensor Value: ");
//  Serial.println(liquidSensorValue);

  //+++++++++++++++++++++++++++++++++++++ D O S I E R P U M P E N +++++++++++++++++++++++++++++++++++++++++++++++++++

  Dosierdauer1 = kalibrieren ( Kalibrierung1, Dosiermenge1, Dosierdauer1);
  Dosierdauer2 = kalibrieren ( Kalibrierung2, Dosiermenge2, Dosierdauer2);
  Dosierdauer3 = kalibrieren ( Kalibrierung3, Dosiermenge3, Dosierdauer3);
  Dosierdauer4 = kalibrieren ( Kalibrierung4, Dosiermenge4, Dosierdauer4);

  Dosierautomatzeit1_1 = (Dosierung1_1.hour * HOUR) + (Dosierung1_1.min * MINUTE) + Dosierung1_1.sec;
  Dosierautomatzeit1_2 = (Dosierung1_2.hour * HOUR) + (Dosierung1_2.min * MINUTE) + Dosierung1_2.sec;
  Dosierautomatzeit1_3 = (Dosierung1_3.hour * HOUR) + (Dosierung1_3.min * MINUTE) + Dosierung1_3.sec;
  Dosierautomatzeit1_4 = (Dosierung1_4.hour * HOUR) + (Dosierung1_4.min * MINUTE) + Dosierung1_4.sec;
  Dosierautomatzeit1_5 = (Dosierung1_5.hour * HOUR) + (Dosierung1_5.min * MINUTE) + Dosierung1_5.sec;
  Dosierautomatzeit1_6 = (Dosierung1_6.hour * HOUR) + (Dosierung1_6.min * MINUTE) + Dosierung1_6.sec;
  Dosierautomatzeit1_7 = (Dosierung1_7.hour * HOUR) + (Dosierung1_7.min * MINUTE) + Dosierung1_7.sec;
  Dosierautomatzeit1_8 = (Dosierung1_8.hour * HOUR) + (Dosierung1_8.min * MINUTE) + Dosierung1_8.sec;
  Dosierautomatzeit1_9 = (Dosierung1_9.hour * HOUR) + (Dosierung1_9.min * MINUTE) + Dosierung1_9.sec;
  Dosierautomatzeit1_10 = (Dosierung1_10.hour * HOUR) + (Dosierung1_10.min * MINUTE) + Dosierung1_10.sec;
  Dosierautomatzeit1_11 = (Dosierung1_11.hour * HOUR) + (Dosierung1_11.min * MINUTE) + Dosierung1_11.sec;
  Dosierautomatzeit1_12 = (Dosierung1_12.hour * HOUR) + (Dosierung1_12.min * MINUTE) + Dosierung1_12.sec;

  Dosierautomatzeit2_1 = (Dosierung2_1.hour * HOUR) + (Dosierung2_1.min * MINUTE) + Dosierung2_1.sec;
  Dosierautomatzeit2_2 = (Dosierung2_2.hour * HOUR) + (Dosierung2_2.min * MINUTE) + Dosierung2_2.sec;
  Dosierautomatzeit2_3 = (Dosierung2_3.hour * HOUR) + (Dosierung2_3.min * MINUTE) + Dosierung2_3.sec;
  Dosierautomatzeit2_4 = (Dosierung2_4.hour * HOUR) + (Dosierung2_4.min * MINUTE) + Dosierung2_4.sec;
  Dosierautomatzeit2_5 = (Dosierung2_5.hour * HOUR) + (Dosierung2_5.min * MINUTE) + Dosierung2_5.sec;
  Dosierautomatzeit2_6 = (Dosierung2_6.hour * HOUR) + (Dosierung2_6.min * MINUTE) + Dosierung2_6.sec;
  Dosierautomatzeit2_7 = (Dosierung2_7.hour * HOUR) + (Dosierung2_7.min * MINUTE) + Dosierung2_7.sec;
  Dosierautomatzeit2_8 = (Dosierung2_8.hour * HOUR) + (Dosierung2_8.min * MINUTE) + Dosierung2_8.sec;
  Dosierautomatzeit2_9 = (Dosierung2_9.hour * HOUR) + (Dosierung2_9.min * MINUTE) + Dosierung2_9.sec;
  Dosierautomatzeit2_10 = (Dosierung2_10.hour * HOUR) + (Dosierung2_10.min * MINUTE) + Dosierung2_10.sec;
  Dosierautomatzeit2_11 = (Dosierung2_11.hour * HOUR) + (Dosierung2_11.min * MINUTE) + Dosierung2_11.sec;
  Dosierautomatzeit2_12 = (Dosierung2_12.hour * HOUR) + (Dosierung2_12.min * MINUTE) + Dosierung2_12.sec;

  Dosierautomatzeit3_1 = (Dosierung3_1.hour * HOUR) + (Dosierung3_1.min * MINUTE) + Dosierung3_1.sec;
  Dosierautomatzeit3_2 = (Dosierung3_2.hour * HOUR) + (Dosierung3_2.min * MINUTE) + Dosierung3_2.sec;
  Dosierautomatzeit3_3 = (Dosierung3_3.hour * HOUR) + (Dosierung3_3.min * MINUTE) + Dosierung3_3.sec;
  Dosierautomatzeit3_4 = (Dosierung3_4.hour * HOUR) + (Dosierung3_4.min * MINUTE) + Dosierung3_4.sec;
  Dosierautomatzeit3_5 = (Dosierung3_5.hour * HOUR) + (Dosierung3_5.min * MINUTE) + Dosierung3_5.sec;
  Dosierautomatzeit3_6 = (Dosierung3_6.hour * HOUR) + (Dosierung3_6.min * MINUTE) + Dosierung3_6.sec;
  Dosierautomatzeit3_7 = (Dosierung3_7.hour * HOUR) + (Dosierung3_7.min * MINUTE) + Dosierung3_7.sec;
  Dosierautomatzeit3_8 = (Dosierung3_8.hour * HOUR) + (Dosierung3_8.min * MINUTE) + Dosierung3_8.sec;
  Dosierautomatzeit3_9 = (Dosierung3_9.hour * HOUR) + (Dosierung3_9.min * MINUTE) + Dosierung3_9.sec;
  Dosierautomatzeit3_10 = (Dosierung3_10.hour * HOUR) + (Dosierung3_10.min * MINUTE) + Dosierung3_10.sec;
  Dosierautomatzeit3_11 = (Dosierung3_11.hour * HOUR) + (Dosierung3_11.min * MINUTE) + Dosierung3_11.sec;
  Dosierautomatzeit3_12 = (Dosierung3_12.hour * HOUR) + (Dosierung3_12.min * MINUTE) + Dosierung3_12.sec;

  Dosierautomatzeit4_1 = (Dosierung4_1.hour * HOUR) + (Dosierung4_1.min * MINUTE) + Dosierung4_1.sec;
  Dosierautomatzeit4_2 = (Dosierung4_2.hour * HOUR) + (Dosierung4_2.min * MINUTE) + Dosierung4_2.sec;
  Dosierautomatzeit4_3 = (Dosierung4_3.hour * HOUR) + (Dosierung4_3.min * MINUTE) + Dosierung4_3.sec;
  Dosierautomatzeit4_4 = (Dosierung4_4.hour * HOUR) + (Dosierung4_4.min * MINUTE) + Dosierung4_4.sec;
  Dosierautomatzeit4_5 = (Dosierung4_5.hour * HOUR) + (Dosierung4_5.min * MINUTE) + Dosierung4_5.sec;
  Dosierautomatzeit4_6 = (Dosierung4_6.hour * HOUR) + (Dosierung4_6.min * MINUTE) + Dosierung4_6.sec;
  Dosierautomatzeit4_7 = (Dosierung4_7.hour * HOUR) + (Dosierung4_7.min * MINUTE) + Dosierung4_7.sec;
  Dosierautomatzeit4_8 = (Dosierung4_8.hour * HOUR) + (Dosierung4_8.min * MINUTE) + Dosierung4_8.sec;
  Dosierautomatzeit4_9 = (Dosierung4_9.hour * HOUR) + (Dosierung4_9.min * MINUTE) + Dosierung4_9.sec;
  Dosierautomatzeit4_10 = (Dosierung4_10.hour * HOUR) + (Dosierung4_10.min * MINUTE) + Dosierung4_10.sec;
  Dosierautomatzeit4_11 = (Dosierung4_11.hour * HOUR) + (Dosierung4_11.min * MINUTE) + Dosierung4_11.sec;
  Dosierautomatzeit4_12 = (Dosierung4_12.hour * HOUR) + (Dosierung4_12.min * MINUTE) + Dosierung4_12.sec;


  //1. Abfrage: Wann soll dosiert werden
  //2. Abfrage: manuelle Zeitschleifensteuerung zur Messung; hier default-Wert 60 Sekunden
  //3. Abfrage: manuelle Streuerung An/Aus
  //Dosierpumpe1
  if  (((lTime >= Dosierautomatzeit1_1) && (lTime <= Dosierautomatzeit1_1 + Dosierdauer1) && (Dosierautomatzeit1_1 != 0) && (Dosiernachfuell_1 == false)) ||
       ((lTime >= Dosierautomatzeit1_2) && (lTime <= Dosierautomatzeit1_2 + Dosierdauer1) && (Dosierautomatzeit1_2 != 0) && (Dosiernachfuell_1 == false)) ||
       ((lTime >= Dosierautomatzeit1_3) && (lTime <= Dosierautomatzeit1_3 + Dosierdauer1) && (Dosierautomatzeit1_3 != 0) && (Dosiernachfuell_1 == false)) ||
       ((lTime >= Dosierautomatzeit1_4) && (lTime <= Dosierautomatzeit1_4 + Dosierdauer1) && (Dosierautomatzeit1_4 != 0) && (Dosiernachfuell_1 == false)) ||
       ((lTime >= Dosierautomatzeit1_5) && (lTime <= Dosierautomatzeit1_5 + Dosierdauer1) && (Dosierautomatzeit1_5 != 0) && (Dosiernachfuell_1 == false)) ||
       ((lTime >= Dosierautomatzeit1_6) && (lTime <= Dosierautomatzeit1_6 + Dosierdauer1) && (Dosierautomatzeit1_6 != 0) && (Dosiernachfuell_1 == false)) ||
       ((lTime >= Dosierautomatzeit1_7) && (lTime <= Dosierautomatzeit1_7 + Dosierdauer1) && (Dosierautomatzeit1_7 != 0) && (Dosiernachfuell_1 == false)) ||
       ((lTime >= Dosierautomatzeit1_8) && (lTime <= Dosierautomatzeit1_8 + Dosierdauer1) && (Dosierautomatzeit1_8 != 0) && (Dosiernachfuell_1 == false)) ||
       ((lTime >= Dosierautomatzeit1_9) && (lTime <= Dosierautomatzeit1_9 + Dosierdauer1) && (Dosierautomatzeit1_9 != 0) && (Dosiernachfuell_1 == false)) ||
       ((lTime >= Dosierautomatzeit1_10) && (lTime <= Dosierautomatzeit1_10 + Dosierdauer1) && (Dosierautomatzeit1_10 != 0) && (Dosiernachfuell_1 == false)) || 
       ((lTime >= Dosierautomatzeit1_11) && (lTime <= Dosierautomatzeit1_11 + Dosierdauer1) && (Dosierautomatzeit1_11 != 0) && (Dosiernachfuell_1 == false)) ||
       ((lTime >= Dosierautomatzeit1_12) && (lTime <= Dosierautomatzeit1_12 + Dosierdauer1) && (Dosierautomatzeit1_12 != 0) && (Dosiernachfuell_1 == false)) ||
       ((Endtime1 > 0) && (lTime <= Endtime1)) || 
       (Dosiermanuell_1 == true) ||
       ((liquidSensorValue == 0) && (Dosiernachfuell_1 == true)))
        
  {        
    //digitalWrite(M1_MENUDOSIERPORT_1, HIGH); //255
    motor1.setSpeed(255);
    motor1.run(FORWARD);
    
  }
  else
  {
    //digitalWrite(M1_MENUDOSIERPORT_1, LOW);
    motor1.run(RELEASE);
    Endtime1 = 0;   
  }

  //Dosierpumpe2
  if  (((lTime >= Dosierautomatzeit2_1) && (lTime <= Dosierautomatzeit2_1 + Dosierdauer2) && (Dosierautomatzeit2_1 != 0) && (Dosiernachfuell_2 == false)) ||
       ((lTime >= Dosierautomatzeit2_2) && (lTime <= Dosierautomatzeit2_2 + Dosierdauer2) && (Dosierautomatzeit2_2 != 0) && (Dosiernachfuell_2 == false)) ||
       ((lTime >= Dosierautomatzeit2_3) && (lTime <= Dosierautomatzeit2_3 + Dosierdauer2) && (Dosierautomatzeit2_3 != 0) && (Dosiernachfuell_2 == false)) ||
       ((lTime >= Dosierautomatzeit2_4) && (lTime <= Dosierautomatzeit2_4 + Dosierdauer2) && (Dosierautomatzeit2_4 != 0) && (Dosiernachfuell_2 == false)) ||
       ((lTime >= Dosierautomatzeit2_5) && (lTime <= Dosierautomatzeit2_5 + Dosierdauer2) && (Dosierautomatzeit2_5 != 0) && (Dosiernachfuell_2 == false)) ||
       ((lTime >= Dosierautomatzeit2_6) && (lTime <= Dosierautomatzeit2_6 + Dosierdauer2) && (Dosierautomatzeit2_6 != 0) && (Dosiernachfuell_2 == false)) ||
       ((lTime >= Dosierautomatzeit2_7) && (lTime <= Dosierautomatzeit2_7 + Dosierdauer2) && (Dosierautomatzeit2_7 != 0) && (Dosiernachfuell_2 == false)) ||
       ((lTime >= Dosierautomatzeit2_8) && (lTime <= Dosierautomatzeit2_8 + Dosierdauer2) && (Dosierautomatzeit2_8 != 0) && (Dosiernachfuell_2 == false)) ||
       ((lTime >= Dosierautomatzeit2_9) && (lTime <= Dosierautomatzeit2_9 + Dosierdauer2) && (Dosierautomatzeit2_9 != 0) && (Dosiernachfuell_2 == false)) ||
       ((lTime >= Dosierautomatzeit2_10) && (lTime <= Dosierautomatzeit2_10 + Dosierdauer2) && (Dosierautomatzeit2_10 != 0) && (Dosiernachfuell_2 == false)) || 
       ((lTime >= Dosierautomatzeit2_11) && (lTime <= Dosierautomatzeit2_11 + Dosierdauer2) && (Dosierautomatzeit2_11 != 0) && (Dosiernachfuell_2 == false)) || 
       ((lTime >= Dosierautomatzeit2_12) && (lTime <= Dosierautomatzeit2_12 + Dosierdauer2) && (Dosierautomatzeit2_12 != 0) && (Dosiernachfuell_2 == false)) || 
       ((Endtime2 > 0) && (lTime <= Endtime2)) || 
       (Dosiermanuell_2 == true) ||
       ((liquidSensorValue == 0) && (Dosiernachfuell_2 == true)))
  {        
    //digitalWrite(M1_MENUDOSIERPORT_2, HIGH); //255
    motor2.setSpeed(255);
    motor2.run(FORWARD);
  }
  else
  {
    //digitalWrite(M1_MENUDOSIERPORT_2, LOW);
    motor2.run(RELEASE);
    Endtime2 = 0;   
  }

  //Dosierpumpe3
  if  (((lTime >= Dosierautomatzeit3_1) && (lTime <= Dosierautomatzeit3_1 + Dosierdauer3) && (Dosierautomatzeit3_1 != 0) && (Dosiernachfuell_3 == false)) ||
       ((lTime >= Dosierautomatzeit3_2) && (lTime <= Dosierautomatzeit3_2 + Dosierdauer3) && (Dosierautomatzeit3_2 != 0) && (Dosiernachfuell_3 == false)) ||
       ((lTime >= Dosierautomatzeit3_3) && (lTime <= Dosierautomatzeit3_3 + Dosierdauer3) && (Dosierautomatzeit3_3 != 0) && (Dosiernachfuell_3 == false)) ||
       ((lTime >= Dosierautomatzeit3_4) && (lTime <= Dosierautomatzeit3_4 + Dosierdauer3) && (Dosierautomatzeit3_4 != 0) && (Dosiernachfuell_3 == false)) ||
       ((lTime >= Dosierautomatzeit3_5) && (lTime <= Dosierautomatzeit3_5 + Dosierdauer3) && (Dosierautomatzeit3_5 != 0) && (Dosiernachfuell_3 == false)) ||
       ((lTime >= Dosierautomatzeit3_6) && (lTime <= Dosierautomatzeit3_6 + Dosierdauer3) && (Dosierautomatzeit3_6 != 0) && (Dosiernachfuell_3 == false)) ||
       ((lTime >= Dosierautomatzeit3_7) && (lTime <= Dosierautomatzeit3_7 + Dosierdauer3) && (Dosierautomatzeit3_7 != 0) && (Dosiernachfuell_3 == false)) ||
       ((lTime >= Dosierautomatzeit3_8) && (lTime <= Dosierautomatzeit3_8 + Dosierdauer3) && (Dosierautomatzeit3_8 != 0) && (Dosiernachfuell_3 == false)) ||
       ((lTime >= Dosierautomatzeit3_9) && (lTime <= Dosierautomatzeit3_9 + Dosierdauer3) && (Dosierautomatzeit3_9 != 0) && (Dosiernachfuell_3 == false)) ||
       ((lTime >= Dosierautomatzeit3_10) && (lTime <= Dosierautomatzeit3_10 + Dosierdauer3) && (Dosierautomatzeit3_10 != 0) && (Dosiernachfuell_3 == false)) || 
       ((lTime >= Dosierautomatzeit3_11) && (lTime <= Dosierautomatzeit3_11 + Dosierdauer3) && (Dosierautomatzeit3_11 != 0) && (Dosiernachfuell_3 == false)) || 
       ((lTime >= Dosierautomatzeit3_12) && (lTime <= Dosierautomatzeit3_12 + Dosierdauer3) && (Dosierautomatzeit3_12 != 0) && (Dosiernachfuell_3 == false)) || 
       ((Endtime3 > 0) && (lTime <= Endtime3)) || 
       (Dosiermanuell_3 == true) ||
       ((liquidSensorValue == 0) && (Dosiernachfuell_3 == true)))
  {        
    //digitalWrite(M1_MENUDOSIERPORT_3, HIGH); //255
    motor3.setSpeed(255);
    motor3.run(FORWARD);
  }
  else
  {
    //digitalWrite(M1_MENUDOSIERPORT_3, LOW);
    motor3.run(RELEASE);
    Endtime3 = 0;   
  }

  //Dosierpumpe4
  if  (((lTime >= Dosierautomatzeit4_1) && (lTime <= Dosierautomatzeit4_1 + Dosierdauer4) && (Dosierautomatzeit4_1 != 0) && (Dosiernachfuell_4 == false)) ||
       ((lTime >= Dosierautomatzeit4_2) && (lTime <= Dosierautomatzeit4_2 + Dosierdauer4) && (Dosierautomatzeit4_2 != 0) && (Dosiernachfuell_4 == false)) ||
       ((lTime >= Dosierautomatzeit4_3) && (lTime <= Dosierautomatzeit4_3 + Dosierdauer4) && (Dosierautomatzeit4_3 != 0) && (Dosiernachfuell_4 == false)) ||
       ((lTime >= Dosierautomatzeit4_4) && (lTime <= Dosierautomatzeit4_4 + Dosierdauer4) && (Dosierautomatzeit4_4 != 0) && (Dosiernachfuell_4 == false)) ||
       ((lTime >= Dosierautomatzeit4_5) && (lTime <= Dosierautomatzeit4_5 + Dosierdauer4) && (Dosierautomatzeit4_5 != 0) && (Dosiernachfuell_4 == false)) ||
       ((lTime >= Dosierautomatzeit4_6) && (lTime <= Dosierautomatzeit4_6 + Dosierdauer4) && (Dosierautomatzeit4_6 != 0) && (Dosiernachfuell_4 == false)) ||
       ((lTime >= Dosierautomatzeit4_7) && (lTime <= Dosierautomatzeit4_7 + Dosierdauer4) && (Dosierautomatzeit4_7 != 0) && (Dosiernachfuell_4 == false)) ||
       ((lTime >= Dosierautomatzeit4_8) && (lTime <= Dosierautomatzeit4_8 + Dosierdauer4) && (Dosierautomatzeit4_8 != 0) && (Dosiernachfuell_4 == false)) ||
       ((lTime >= Dosierautomatzeit4_9) && (lTime <= Dosierautomatzeit4_9 + Dosierdauer4) && (Dosierautomatzeit4_9 != 0) && (Dosiernachfuell_4 == false)) ||
       ((lTime >= Dosierautomatzeit4_10) && (lTime <= Dosierautomatzeit4_10 + Dosierdauer4) && (Dosierautomatzeit4_10 != 0) && (Dosiernachfuell_4 == false)) || 
       ((lTime >= Dosierautomatzeit4_11) && (lTime <= Dosierautomatzeit4_11 + Dosierdauer4) && (Dosierautomatzeit4_11 != 0) && (Dosiernachfuell_4 == false)) || 
       ((lTime >= Dosierautomatzeit4_12) && (lTime <= Dosierautomatzeit4_12 + Dosierdauer4) && (Dosierautomatzeit4_12 != 0) && (Dosiernachfuell_4 == false)) || 
       ((Endtime4 > 0) && (lTime <= Endtime4)) || 
       (Dosiermanuell_4 == true) ||
       ((liquidSensorValue == 0) && (Dosiernachfuell_4 == true)))
  {        
    //digitalWrite(M1_MENUDOSIERPORT_4, HIGH); //255
    motor4.setSpeed(255);
    motor4.run(FORWARD);
  }
  else
  {
    //digitalWrite(M1_MENUDOSIERPORT_4, LOW);
    motor4.run(RELEASE);
    Endtime4 = 0;   
  }



}






